Skip navigation links

Overview | Package | Class | Tree | Index | Help
| Oracle® Coherence Java API Reference Release 3.6.0.0 E15725-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.tangosol.io.nio
Class ByteBufferInputStream

`java.lang.Object
java.io.InputStream
com.tangosol.io.nio.ByteBufferInputStream`

All Implemented Interfaces:
  InputStreaming, Closeable

      public class ByteBufferInputStream

extends InputStream
implements InputStreaming

An InputStream implementation on top of a Java NIO ByteBuffer.

Since:
  Coherence 2.2
Author:
  cp 2002.09.06

Field Summary
`protected ByteBuffer` | `m_buf` The ByteBuffer object from which data is read.

Constructor Summary
`ByteBufferInputStream(ByteBuffer buffer)` Construct a ByteBufferInputStream on a ByteBuffer object.

Method Summary
`int` | `available()` Returns the number of bytes that can be read (or skipped over) from this input stream without blocking by the next caller of a method for this input stream.
`void` | `close()` Close the stream, flushing any accumulated bytes.
`ByteBuffer` | `getByteBuffer()` Obtain the ByteBuffer that this InputStream is based on.
`void` | `mark(int readlimit)` Marks the current position in this input stream.
`boolean` | `markSupported()` Tests if this input stream supports the `mark` and `reset` methods.
`protected NullPointerException` | `potentialStreamClosedException(NullPointerException e)` Check if an NPE is caused by the stream being closed.
`int` | `read()` Reads the next byte of data from the input stream.
`int` | `read(byte[] abDest, int ofDest, int cbDest)` Reads up to `len` bytes of data from the input stream into an array of bytes.
`void` | `reset()` Repositions this stream to the position at the time the `mark` method was last called on this input stream.
`long` | `skip(long lcb)` Skips over and discards `n` bytes of data from this input stream.

Methods inherited from class java.io.InputStream
`read`

Methods inherited from interface com.tangosol.io.InputStreaming
`read`

Field Detail

### m_buf

    protected ByteBuffer m_buf

  The ByteBuffer object from which data is read.

Constructor Detail

### ByteBufferInputStream

    public ByteBufferInputStream(ByteBuffer buffer)

  Construct a ByteBufferInputStream on a ByteBuffer object.
  Parameters:
    `buffer` - the ByteBuffer to read the data from

Method Detail

### getByteBuffer

    public ByteBuffer getByteBuffer()

  Obtain the ByteBuffer that this InputStream is based on.
  Returns:
    the underlying ByteBuffer

### read

    public int read()
             throws IOException

  Reads the next byte of data from the input stream. The value byte is returned as an `int` in the range `0` to `255`. If no byte is available because the end of the stream has been reached, the value `-1` is returned. This method blocks until input data is available, the end of the stream is detected, or an exception is thrown.
  Specified by:
    `read` in interface `InputStreaming`
  Specified by:
    `read` in class `InputStream`
  Returns:
    the next byte of data, or `-1` if the end of the stream is reached
  Throws:
    `IOException` - if an I/O error occurs

### read

    public int read(byte[] abDest,
                    int ofDest,
                    int cbDest)
             throws IOException

  Reads up to `len` bytes of data from the input stream into an array of bytes. An attempt is made to read as many as `len` bytes, but a smaller number may be read, possibly zero. The number of bytes actually read is returned as an integer.
  Specified by:
    `read` in interface `InputStreaming`
  Overrides:
    `read` in class `InputStream`
  Parameters:
    `abDest` - the buffer into which the data is read
    `ofDest` - the start offset in array `b` at which the data is written
    `cbDest` - the maximum number of bytes to read
  Returns:
    the total number of bytes read into the buffer, or `-1` if there is no more data because the end of the stream has been reached.
  Throws:
    `IOException` - if an I/O error occurs

### skip

    public long skip(long lcb)
              throws IOException

  Skips over and discards `n` bytes of data from this input stream. The `skip` method may, for a variety of reasons, end up skipping over some smaller number of bytes, possibly `0`. This may result from any of a number of conditions; reaching end of file before `n` bytes have been skipped is only one possibility. The actual number of bytes skipped is returned. If `n` is negative, no bytes are skipped.
  Specified by:
    `skip` in interface `InputStreaming`
  Overrides:
    `skip` in class `InputStream`
  Parameters:
    `lcb` - the number of bytes to be skipped
  Returns:
    the actual number of bytes skipped
  Throws:
    `IOException` - if an I/O error occurs

### available

    public int available()
                  throws IOException

  Returns the number of bytes that can be read (or skipped over) from this input stream without blocking by the next caller of a method for this input stream. The next caller might be the same thread or or another thread.
  Specified by:
    `available` in interface `InputStreaming`
  Overrides:
    `available` in class `InputStream`
  Returns:
    the number of bytes that can be read from this input stream without blocking.
  Throws:
    `IOException` - if an I/O error occurs

### mark

    public void mark(int readlimit)

  Marks the current position in this input stream. A subsequent call to the `reset` method repositions this stream at the last marked position so that subsequent reads re-read the same bytes.
  Specified by:
    `mark` in interface `InputStreaming`
  Overrides:
    `mark` in class `InputStream`
  Parameters:
    `readlimit` - the maximum limit of bytes that can be read before the mark position becomes invalid

### reset

    public void reset()
               throws IOException

  Repositions this stream to the position at the time the `mark` method was last called on this input stream.
  Specified by:
    `reset` in interface `InputStreaming`
  Overrides:
    `reset` in class `InputStream`
  Throws:
    `IOException` - if an I/O error occurs.

### markSupported

    public boolean markSupported()

  Tests if this input stream supports the `mark` and `reset` methods. The `markSupported` method of `InputStream` returns `false`.
  Specified by:
    `markSupported` in interface `InputStreaming`
  Overrides:
    `markSupported` in class `InputStream`
  Returns:
    `true` if this true type supports the mark and reset method; `false` otherwise

### close

    public void close()
               throws IOException

  Close the stream, flushing any accumulated bytes. The underlying buffer is not closed.
  Specified by:
    `close` in interface `InputStreaming`
  Specified by:
    `close` in interface `Closeable`
  Overrides:
    `close` in class `InputStream`
  Throws:
    `IOException` - if an I/O error occurs.

### potentialStreamClosedException

    protected NullPointerException potentialStreamClosedException(NullPointerException e)
                                                           throws IOException

  Check if an NPE is caused by the stream being closed. Either throws an IO exception if the stream is closed or throws the original NPE.
  Parameters:
    `e` - an NPE
  Returns:
    this method never returns normally but is designed so that the developer can write "throw potentialStreamClosedException(e)" so that the compiler knows that an exception is thrown at that point in the code
  Throws:
    `IOException` - if the stream is closed

Skip navigation links

Overview | Package | Class | Tree | Index | Help
| Oracle® Coherence Java API Reference Release 3.6.0.0 E15725-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000, 2010, Oracle and/or its affiliates. All rights reserved.